#ifndef UTILS_H
#define UTILS_H

double *cpyv3(double* u, double* v);
double *negv3(double* u, double* v);
double *addv3(double* u, double* v, double* w) ;
double *subv3(double* u, double* v, double* w) ;
double carrev3(double* a) ;
double dotv3(double* a, double* b);
double longv3(double* a);
double lunitv3(double* a, double* b);
double *scav3(double* u, double s, double* v);
double *cumv3(double* u, double* v,double a, double* w);
double *crossv3(double* a, double* b, double* c);
double *cpym3(double* A, double* B);
double *tm3(double *a);
double *scam3(double* A, double s, double* B);
double *m3v3(double* w, double* a, double* v) ;
double *tm3v3(double* w, double* a, double* v);
double *m3m3(double* a,double* b, double* c);
double *invm3(double* a);
double *av3tomrot(double* m, double a, double* v);
double *v3tomrot(double* m, double* v);
double *cpyvec (double* u, double* v, int n);
double *addvec (double* u, double* v, double* w, int n);
double *subvec (double* u, double* v, double* w, int n);
double ninfvec (double* u, int n);
double *scavec (double *u, double a, double *v, int n);
double *cumvec (double* u, double* v, double s, double* w, int n);
double *mulvec (double* u, double* v, double* w, int n);
double *matmat (double *A, double *B, double *C, int m, int n, int p) ;
double *tmatmat (double *a, double *b, double *c, int m, int n, int p);
double *mattmat (double *a, double *b, double *c, int m, int n, int p);
double *mMuV2(double *a, double m, double *v) ;
double *carol2mrot(double *a, double *carol);
#endif