#include <windows.h>
#include "glut.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#ifndef M_PI
#define M_PI   3.14159265358979323846
#endif
#ifndef M_SQRT2
#define M_SQRT2   1.41421356237309504880
#endif
#define RAD2DEG (180./M_PI)
#define DEG2RAD (M_PI/180.)

/*----------------------------------------------------------------------------------*/
/*     Declaration de fonctions utilises (externes et/ou internes)                 */
/*----------------------------------------------------------------------------------*/
#include "utils.h"
void Geodir(double *Qi, double *A, double *OA, int FlagExact) ;
static int FlagExact = 1;
static void Lecture(void);
static int InitLecture(void);
static void	  (*Idle_inData)(void) = 0 ;

/* Messages d'erreur */
static int meserrlec = 0, mesdatnok = 0;
static char txterrlec[] = "  ECHEC OUVERTURE FICHIER";
static char txtdatnok[] = "  FICHIER FORMAT INCORRECT";

#define LOCAL    0
#define LECFICH  1
static int DevInput = LOCAL; 
static FILE *fdata = NULL;

/*----------------------------------------------------------------------------------*/
/* Description des objets dessins (Dysplays Lists OpenGL)                          */
/*----------------------------------------------------------------------------------*/
static GLuint DL_Corps;/* Corps du Mirage */
static GLuint DL_Aileron_D, DL_Aileron_G;/* Ailerons Mirage */
static GLuint DL_Cone;/* Pointe des flches */
static GLuint DL_Poulie;/* Une poulie */
static GLuint DL_Veine;/* Veine soufflerie */

/*----------------------------------------------------------------------------------*/
/* Donnes gomtriques                                                             */
/*----------------------------------------------------------------------------------*/
extern int flagbas[];	/* 1 pour poulies basses */
extern double Rpoul, OHi[], OAi[], ABi[]; /* point d'accroche des cables */
#define Epouls2 0.0025
#define Epoul 0.005
/*----------------------------------------------------------------------------------*/
/* Etat courant                                                                     */
/*----------------------------------------------------------------------------------*/
static double OA[12], Carol[3] ; /* Situation courante std. MLL et Carol en degrs  */
static double T[9]; /* tensions courantes dans les cables */

/*----------------------------------------------------------------------------------*/
/*  Caractristiques fenetres de visualisation                                      */
/*----------------------------------------------------------------------------------*/
static int f1, f2; /* numero de la fenetres */
static int width1 = 720; /*largeur fenetre 1 */
static int height1 = 576; /*hauteur fenetre 1*/
static int width2 = 430; /*largeur fenetre 2 */
static int height2 = 335; /*hauteur fenetre 2*/
static int AideCree = 0;
/* position de l'observateur  fenetre 1 */
#define ELOING 10.
#define SITE 20.0
#define AZIMUT -120.0
static int	Perspective = 1;    /* Flag utilisation perspectives  */
static double AngleVueVertical = 30. ; /* en degrs */
static double Eloignement = ELOING; /* de l'observateur */
static double Azimut = AZIMUT, Site = SITE; /* Direction de l'observateur */
static double Wdroit = 0., Whaut = 0.; /* Dplacement cran */
/*----------------------------------------------------------------------------------*/
/*  Traitement des actions sur les touches                                          */
/*----------------------------------------------------------------------------------*/
/* Incrments commande manuelle */
static double DeltaL = 0.05, DeltaA = 2.5, DeltaF = 0.5, DeltaM = 0.05 ;

/*----------------------------------------------------------------------------------*/
/* Utilitaire d'affichage de ligne de caractres  l'cran                          */
/*----------------------------------------------------------------------------------*/
static void AffichStr(int x, int y, char *string )
{
int len, i;

	glRasterPos2i(x, y);
	len = (int) strlen(string);
	for (i = 0; i < len; i++)
	{
		glutBitmapCharacter(GLUT_BITMAP_8_BY_13, string[i]);
	}
}

/*----------------------------------------------------------------------------------*/
/* Callack dessin fenetre aide                                                      */
/*----------------------------------------------------------------------------------*/
static void Redraw2(void)
{
int ihaut;
char texte[256];
	glViewport(0,0,width2,height2);
	glClear(GL_COLOR_BUFFER_BIT);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0.0, 1.*width2, 0.0, 1.*height2, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	glColor3d(0., 0.,0.);

	strcpy(texte, " ATTENTION : FIN VISU SACSO EN FERMANT CETTE FENETRE"); ihaut = height2-15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "   !!! FERMEZ-LA A L'AIDE DU MENU CONTEXTUEL !!!"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, " OU BIEN CONSERVEZ-LA A COTE DE LA FENETRE PRINCIPALE"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, " ACTION DES TOUCHES DU CLAVIER : "); ihaut -= 30; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "  p pour projection orthogonale"); ihaut -= 30; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "  P pour perspective"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, " Mouvements maquette : "); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    0,o,O: Retour origine"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    x, X : +/- Translation/Force en x"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    y, Y : +/- Translation/Force en y"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    z, Z : +/- Translation/Force en z"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    r, R : +/- Rotation/Moment en roulis(x)"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    t, T : +/- Rotation/Moment en tangage(y)"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    l, L : +/- Totation/Moment en lacet (z)"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, " Mouvements observateur : "); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    e, E         : +/- eloignement"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    d, D         : +/- droite"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    h, H         : +/- haut"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    fleches >, < : dplacement en azimut"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    fleches ^, V : dplacement en site"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	strcpy(texte, "    c, C         : retour point de vue initial"); ihaut -= 15; AffichStr (0, ihaut, texte) ;
	glFlush();
}

static void Resize2(int w, int h) 
{
    /* Memo les nouvelles valeurs */
    width2  = w;
    height2 = h;
}
/*----------------------------------------------------------------------------------*/
/* Callack traitement du menu contextuel                                                    */
/*----------------------------------------------------------------------------------*/
#define MENU_AIDE		1
#define MENU_selectXouF	2
#define MENU_LECFICH	3

#define X_SELECT 1    /* Les touches modifient la position */
#define F_SELECT 2	  /* Les touches modifient les efforts */

static int fModeXouF = X_SELECT;

static void TraiteMenu1(int value)
{
	switch(value)
	{
	case MENU_selectXouF :
		if (fModeXouF ==  X_SELECT) 
		{ 
			fModeXouF = F_SELECT ;
			glutChangeToMenuEntry(MENU_selectXouF, "Cde en Pos/Orient.", MENU_selectXouF);
		}
		else 
		{	
			fModeXouF = X_SELECT ;
			glutChangeToMenuEntry(MENU_selectXouF, "Cde en Force/Couple", MENU_selectXouF);
		}
		break ;
	case MENU_AIDE :
		if (!AideCree)
		{
			glutInitDisplayMode(GLUT_RGBA);
			glutInitWindowSize(width2, height2);
			f2 =  glutCreateWindow("Aide Visu Sacso");
			glClearColor(0.85, 0.95, 0.95, 1.0);
			glutDisplayFunc(Redraw2);
			glutReshapeFunc(Resize2);
			AideCree = 1;
			glutChangeToMenuEntry(MENU_AIDE, "Fermer Aide", MENU_AIDE);
		}
		else 
		{
/*			glutSetWindow(f2);
			glutShowWindow();
			glutPopWindow(); */
			glutDestroyWindow(f2);
			glutChangeToMenuEntry(MENU_AIDE, "Aide Visu", MENU_AIDE);
			AideCree = 0;
		}
		break ;

	case MENU_LECFICH :
		switch (DevInput)
		{
		case LECFICH : /* On tait en lecture fichier */
			fclose(fdata); 
			DevInput = LOCAL;
			glutChangeToMenuEntry(MENU_LECFICH, "Lecture Fichier", MENU_LECFICH);
			break;

		case LOCAL :
		default :  /* On tait en local */
			if (InitLecture()) break ; /* Echec Lecture fichier */
			glutChangeToMenuEntry(MENU_LECFICH, "Arrter Lecture", MENU_LECFICH);
			DevInput = LECFICH;
			Idle_inData = Lecture;
			glutIdleFunc(Idle_inData) ;
			break;
		}
		break ;
	}
	glutPostRedisplay();
}


/*----------------------------------------------------------------------------------*/
/* Callback de traitement demande de re-dimensionnement fenetre 1                   */
/*----------------------------------------------------------------------------------*/
static void Resize1(int w, int h) 
{
    /* Memo les nouvelles valeurs */
    width1  = w;
    height1 = h;
}

/*----------------------------------------------------------------------------------*/
/* Utilitaire conversion situation MLL -> Situation OpenGL                          */
/*----------------------------------------------------------------------------------*/
static double *sit2mat44(double *m44, double *sit)
{
    m44[0] = sit[3] ; m44[4] = sit[6] ;  m44[8]  = sit[ 9] ; m44[12] = sit[0] ;
    m44[1] = sit[4] ; m44[5] = sit[7] ;  m44[9]  = sit[10] ; m44[13] = sit[1] ;
    m44[2] = sit[5] ; m44[6] = sit[8] ;  m44[10] = sit[11] ; m44[14] = sit[2] ;
	m44[3] = 0.     ; m44[7] = 0.     ;  m44[11] = 0.      ; m44[15] = 1. ;
	return m44 ;
}


/*----------------------------------------------------------------------------------*/
/* Callback dessinant la figure                                                     */
/*----------------------------------------------------------------------------------*/
/* Pour le test ralisabilt en local */
double dmin2segs(double *A, double *B, double *C, double *D);
int Statinv (double *Fq, double *Fxdes, double *A, double *tmin, double *tmax,
									double *tref, double *tpon, int Satur);
static double tmax[9] = {120.,240.,240.,120.,120.,240.,240.,120.,120.};
static double tpon[9] = {120.,240.,240.,120.,120.,240.,240.,120.,120.};
static double tref[9] = {36.,72.,72.,36.,36.,72.,72.,36.,36.};
static double tmin[9] = {10.,10.,10.,10.,10.,10.,10.,10.,10.};
static double Fxdes[6] = {0.,0.,0.,0.,0.,0.};
/* #define DRAWCONE */
static void Redraw1(void)
{
GLfloat pos_lumiere1[]={0.,0.3,1.,0.}; /* derrire l'observateur et au dessus */
double Dx,Dy, Infini = 1000.*Eloignement;
double OTi[27], ABi_o[27], OBi_o[27];
double Astat[6*9], di[9];
double mat44[16], *Com = OA+3, *ui = Astat;
int i, i3, i6, ibas , ihaut;
char texte[256];
double wwlong, angleww, ww[3];

    if (height1 == 0) return ; 

	/* Calul longueur cbles et directions (dans Asrat) */
    Geodir(di, Astat, OA, FlagExact) ;

	/* Position point d'ancrages mobiles dans Ro */
	matmat(ABi_o,Com,ABi,3,3,9);	/* calcul ABi_o */
	for(i3 = 0; i3 < 27; i3 += 3)		/* calcul OBi_o */
    {
	    OBi_o[i3]   = OA[0] + ABi_o[i3] ;
	    OBi_o[i3+1] = OA[1] + ABi_o[i3+1] ;
	    OBi_o[i3+2] = OA[2] + ABi_o[i3+2] ;
	}  


	/**********************************/
	/*  fenetre 1                     */
	/**********************************/
	glViewport(0,0,width1,height1);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glEnable(GL_DEPTH_TEST);
	glMatrixMode(GL_PROJECTION); 
	glLoadIdentity(); /* la matrice identite est chargee comme matrice de projection */
	if(Perspective)
		gluPerspective(AngleVueVertical, 1.*width1/height1, 0.01, Infini);
	else
	{
		Dy = Eloignement*tan(0.5*AngleVueVertical*M_PI/180.);
		Dx = Dy*width1/height1;
		glOrtho(-Dx, Dx, -Dy, Dy, 0.01, Infini);
	}
	/**********************************/
	/* Construction de la scene       */
	/**********************************/
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	/**********************************/
	/* L'clairage                    */
	/**********************************/
    glEnable(GL_LIGHTING);
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE); /* Les 2 faces sont traites */
    glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE); 
	/* choix parmi : GL_EMISSION, GL_AMBIENT, GL_DIFFUSE, GL_SPECULAR, GL_AMBIENT_AND_DIFFUSE */ 
    glEnable(GL_COLOR_MATERIAL);
    glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0, GL_POSITION, pos_lumiere1);

	/* Positionnement inverse de l'observateur */
	glTranslated(Wdroit + 0.,Whaut  -1., -Eloignement);
	glRotatef(Site, 1.0, 0.0, 0.0); 
	glRotatef(Azimut, 0.0, 1.0, 0.0); 
	glRotatef(-90., 1.0, 0.0, 0.0); /* Repre avec Z vertical */
	/* La soufflerie  */
	glCallList(DL_Veine);
	glRotatef(90., 0.0, 1.0, 0.0);  /* Repre Saxo X vers le bas */
	glPushMatrix(); /* On push le repere Sacso */
		/* Transformations pour situation dans repere avion */
		sit2mat44(mat44,OA);
		glMultMatrixd(mat44); /* On est dans le repere avion */
		glCallList(DL_Corps);
	glPopMatrix(); /* Retour repere Sacso */

	/* Les cables, tensions et poulies */
	for (i=i3=0; i < 9 ;i++, i3 += 3)
	{
		/* Les cables sans fioriture */
		glColor3d(0.1,0.,0.);
		glLineWidth(1.);
		glBegin(GL_LINES);
			glVertex3dv(&OBi_o[i3]);
			glVertex3dv(&OAi[i3]);
		glEnd() ;
		/* Sur-paisseur et flche pour les tensions */
		/* OTi = OBi + Ti.ui_o */
		i6 = i3+i3;
		cumv3(&OTi[i3], &OBi_o[i3], T[i]*di[i]/250., &ui[i6]);
		glLineWidth(2.5);
		glColor3d(0.,0.,0.7);
		glBegin(GL_LINES);
			glVertex3dv(&OBi_o[i3]);
			glVertex3dv(&OTi[i3]);
		glEnd();
#ifdef DRAWCONE  /* Dessin des flches en bout des tensions */
		glPushMatrix(); /* Push rep. Sacso */
			ww[0]= -ui[i6+1];
			ww[1]= ui[i6+0];
			ww[2]=0.0;
			wwlong = longv3(ww);
			angleww = atan2(wwlong, ui[i6+2])*RAD2DEG;
			glTranslated(OTi[i3],OTi[i3+1],OTi[i3+2]);  
			glRotated(angleww,ww[0],ww[1],ww[2]);
			glCallList(DL_Cone);
		glPopMatrix(); /* Retour repere SACSO */
#endif
		/* Les poulies */
		glPushMatrix(); /* Push rep. Sacso */
			ww[0]= 0.0;
			ww[1]= ui[i6+1];
			ww[2]= ui[i6+2];
			wwlong = lunitv3(ww,ww);
			angleww = atan2(ww[2], ww[1])*RAD2DEG;
			glTranslated(OHi[i3],  OHi[i3+1]-Rpoul*ww[1], OHi[i3+2]-Rpoul*ww[2]);  
			glRotated(angleww,1.,0.,0.);
			glCallList(DL_Poulie);
		glPopMatrix(); /* Retour repere SACSO */
	}
	glDisable(GL_COLOR_MATERIAL);
	glDisable(GL_DEPTH_TEST); 
	glDisable(GL_LIGHTING);
/*------------------------------------------------*/
/*            Affichage des textes                */
/*------------------------------------------------*/
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0.0, 1.*width1, 0.0, 1.*height1, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	glColor3d(0., 0.,0.);

	ihaut = height1;
	i = sprintf(texte,"    X = %+5.3lf  Y = %+5.3lf  Z = %+5.3lf", 
		OA[0], OA[1], OA[2]);
	sprintf(texte+i," Cap = %+5.1lf  Assiette = %+5.1lf Roulis = %+5.1lf", 
		Carol[0], Carol[1], Carol[2]);
	ihaut -= 15; AffichStr (0, ihaut, texte) ;


	ibas = 3; strcpy(texte, "LKK");for (i=0;i<3;i++) texte[i] += 1;
	AffichStr (width1 - 24, ibas, texte) ;
	ibas -= 15;

	if(meserrlec)
	{
		meserrlec = 0; ibas += 15; AffichStr (0, ibas, txterrlec) ;
	}
	if(mesdatnok)
	{
		mesdatnok = 0; ibas += 15; AffichStr (0, ibas, txtdatnok) ;
	}

	if (DevInput == LOCAL)
	{
		/* Contact entre cables avant et fuselage si Uz_m change de signe */ 
		for (i = 1; i <= 2; i++) if (dotv3(ui+6*i, Com+6) <= 0.)
		{
			sprintf(texte,"    ATTENTION CONTACT CABLE %d ET FUSELAGE",i+1); 
			ibas += 15 ; AffichStr (0, ibas, texte) ;
		}
		for (i = 5; i <= 6; i++) if (dotv3(ui+6*i, Com+6) >= 0.)
		{
			sprintf(texte,"    ATTENTION CONTACT CABLE %d ET FUSELAGE",i+1); 
			ibas += 15 ; AffichStr (0, ibas, texte) ;
		}

		/* Contact entre cbles 1-4 ou 1-5  si leur distance devient infrieure
		   au demi entre axe en y des attaches 4-5 */
		for (i = 3; i <= 4; i++)
		{
			if (ABi[3*3+1] > dmin2segs(OAi, OBi_o, OAi+i*3, OBi_o+i*3))
			{

				sprintf(texte,"    ATTENTION CONTACT ENTRE CABLES 1 ET %d",i+1); 
				ibas += 15 ; AffichStr (0, ibas, texte) ;
			}
		}

		/* Contact entre cbles 4-8 ou 5-9 si leur distance devient 
		   infrieure  2 mm */
		for (i = 3; i <= 4; i++)
		{
			if (0.02 > dmin2segs(OAi+i*3, OBi_o+i*3, OAi+3*(i+4), OBi_o+3*(i+4)))
			{

				sprintf(texte,"    ATTENTION CONTACT ENTRE CABLES %d ET %d",i+1, i+5); 
				ibas += 15 ; AffichStr (0, ibas, texte) ;
			}
		}

		i = Statinv (T, Fxdes, Astat, tmin, tmax, tref, tpon, 1);
		if (i == -10) {ibas += 15; AffichStr (0, ibas, "   TENSIONS CABLES HORS LIMITES : ECHEC STATINV");}
		else if (i < 0) 
		{
			sprintf(texte,"  TENSIONS CABLES HORS LIMITES : SOLUTION FAUSSE %d tensions satures",-i); 
			ibas += 15. ; AffichStr (0, ibas, texte);
		}
		else if (i > 0) 
		{
			sprintf(texte,"  SOLUTION EXACTE MAIS %d tension(s) cble(s) sature(s)",i); 
			ibas += 15. ; AffichStr (0, ibas, texte);
		}
	}
	else matmat (Fxdes, Astat, T, 6, 9, 1) ;

	sprintf(texte,"Tensions : %+7.2lf %+7.2lf %+7.2lf %+7.2lf %+7.2lf %+7.2lf %+7.2lf %+7.2lf %+7.2lf",
		T[0],T[1],T[2],T[3],T[4],T[5],T[6],T[7],T[8]);
	ihaut -= 15; AffichStr (0, ihaut, texte) ;

	sprintf(texte,"Torseur cable : %+7.2lf %+7.2lf %+7.2lf %+7.2lf %+7.2lf %+7.2lf",
			Fxdes[0],Fxdes[1],Fxdes[2],Fxdes[3],Fxdes[4],Fxdes[5]);
	ihaut -= 15; AffichStr (0, ihaut, texte) ;
    
	
	/* On swappe les buffers */
    glutSwapBuffers();
}

/*----------------------------------------------------------------------------------*/
/* Callback traitant les touches flches pour modifier le point de vue              */
/*----------------------------------------------------------------------------------*/
static void Specialkeys1(int key, int x, int y)
{
	switch (key)
	{
	case GLUT_KEY_UP :
		Site += DeltaA ;
		break ;
	case GLUT_KEY_DOWN :
		Site -= DeltaA ;
		break ;
	case GLUT_KEY_LEFT :
		Azimut += DeltaA ;
		if (Azimut > 180.) Azimut -= 360. ;
		break ;
	case GLUT_KEY_RIGHT :
		Azimut -= DeltaA ;
		if (Azimut < -180.) Azimut += 360. ;
		break ;
	}
	glutPostRedisplay();

}

/*----------------------------------------------------------------------------------*/
/* Callback traitement touches ordinaires pour actions diverses                     */
/*                                                                                  */
/* G		: met la maquette au centre												*/
/* a,A      : modifie l'assiette                                                    */
/* c,C      : modifie le cap                                                        */
/* e,E      : Eloigne ou approche l'observateur                                     */
/* r,R      : modifie le roulis                                                     */
/* x,X,y,Y,z,Z : modifie la position de la maquette                                 */
/*----------------------------------------------------------------------------------*/
static void Keyboard1(unsigned char key, int x, int y)
{
int matOAnok;
double bid[3];

	matOAnok = 0;
    switch (key)
    {
    case '0' : /* au centre */
    case 'o' : /* au centre */
    case 'O' : /* au centre */
		if (fModeXouF == X_SELECT)
		{
			OA[0]=-1.0;
			OA[1]=0.0;
			OA[2]=0.0;
			Carol[0]=0.0;
			Carol[1] =0.0;
			Carol[2]=0.0;
			matOAnok = 1;
		}
		else
		{ Fxdes[0] = Fxdes[1] = Fxdes[2] = Fxdes[3] = Fxdes[4] = Fxdes[5] =0.;} 
      break;
#if 0
	case 's' : /* modle simplifi */
		FlagExact = 0; 
		break ;
	case 'S' : /* modle exact */
		FlagExact = 1; 
		break ;
#endif
	case 'd' : /* fenetre a droite */
		Wdroit += DeltaL ;
		break ;
	case 'D' : /* fenetre a gauche */
		Wdroit -= DeltaL ;
		break ;
	case 'h' : /* fenetre en haut */
		Whaut += DeltaL ;
		break ;
	case 'H' : /* fenetre en bas */
		Whaut -= DeltaL ;
		break ;
	case 'c' : /* Point de vue initial */
	case 'C' : 
		Wdroit = 0. ;
		Whaut = 0.;
		Eloignement = ELOING;
		Azimut = AZIMUT; Site = SITE;
		break ;
	case 'e' : /* Eloignement */
		Eloignement += DeltaL ;
		break ;
	case 'E' : /* Cap */
		Eloignement -= DeltaL ;
		break ;
	case 'x' :
	    if (fModeXouF == X_SELECT) OA[0] += DeltaL ;
		else Fxdes[0] += DeltaF ;
		break ;
	case 'X' :
		if (fModeXouF == X_SELECT) OA[0] -= DeltaL ;
		else Fxdes[0] -= DeltaF ;
		break ;
	case 'y' :
		if (fModeXouF == X_SELECT) OA[1] += DeltaL ;
		else Fxdes[1] += DeltaF ;	
		break ;
	case 'Y' :
		if (fModeXouF == X_SELECT) OA[1] -= DeltaL ;
		else Fxdes[1] -= DeltaF ;
		break ;
	case 'z' :
		if (fModeXouF == X_SELECT) OA[2] += DeltaL ;
		else Fxdes[2] += DeltaF ;	
		break ;
	case 'Z' :
		if (fModeXouF == X_SELECT) OA[2] -= DeltaL ;
		else Fxdes[2] -= DeltaF ;	
		break ;
	case 'r' : /* Roulis */
		if (fModeXouF == X_SELECT) 
		{
			Carol[2] += DeltaA ;
			if (Carol[2]   >  180.0) Carol[2]   -= 360.0;
			matOAnok = 1;
		}
		else Fxdes[3] += DeltaM ;	
		break ;
	case 'R' : /* Roulis */
		if (fModeXouF == X_SELECT) 
		{
			Carol[2] -= DeltaA ;
			if (Carol[2]   < -180.0) Carol[2]   += 360.0;
			matOAnok = 1;
		}
		else Fxdes[3] -= DeltaM ;	
		break ;
	case 't' : /* Assiette */
		if (fModeXouF == X_SELECT) 
		{
			Carol[1] += DeltaA ;
			if (Carol[1] >  180.0) Carol[1] -= 360. ;
			matOAnok = 1;
		}
		else Fxdes[4] += DeltaM ;	
		break ;
	case 'T' : /* Assiette */
		if (fModeXouF == X_SELECT) 
		{
			Carol[1] -= DeltaA ;
			if (Carol[1] < -180.0) Carol[1] += 360. ;
			matOAnok = 1;
		}
		else Fxdes[4] -= DeltaM ;	
		break ;
	case 'l' : /* Cap */
		if (fModeXouF == X_SELECT) 
		{
			Carol[0] += DeltaA ;
			if (Carol[0]      >  360.0) Carol[0]      -= 360.0;
			matOAnok = 1;
		}
		else Fxdes[5] += DeltaM ;	
		break ;
	case 'L' : /* Cap */
		if (fModeXouF == X_SELECT) 
		{
			Carol[0] -= DeltaA ;
			if (Carol[0]      <    0.0) Carol[0]      += 360.0;
			matOAnok = 1;
		}
		else Fxdes[5] -= DeltaM ;	
		break ;
	case 'p' : /* Perspective */
	    Perspective = 0 ;
	    break;
	case 'P' : /* Perspective */
	    Perspective = 1 ;
	    break;
	}
	if (matOAnok) carol2mrot(OA+3,scav3(bid,DEG2RAD,Carol));
	glutPostRedisplay();
} 

/*----------------------------------------------------------------------------------*/
/* glu_vertex() : Association point - texture pour les mosaques                    */
/*----------------------------------------------------------------------------------*/
static void APIENTRY glu_vertex(GLdouble *xyz)
{
    glTexCoord2dv(xyz + 3); /* Coordonnes texture */
    glVertex3dv(xyz);		/* Coordones points */
}

/*----------------------------------------------------------------------------------*/
/*  Constructions des formes  dessiner                                             */
/*----------------------------------------------------------------------------------*/
#define NbptAiles 13
#define NbptDerive 6
#define NbptAileron 4


static void makemirage()
{
int i, i3;
/* couleurs */
double colfuselage[]={70.0/255.0,130.0/255.0,180.0/255.0};
double colgrisnoir[]= {0.15,0.15,0.015};
double colailes[]= {70.0/255.0,130.0/255.0,180.0/255.0};
double colaileron[]= {70.0/255.0,130.0/255.0,180.0/255.0};

/* clairage*/
static GLUquadricObj *quadric;
GLUtriangulatorObj *tess;

/* definition/declaration des points dans repere avion (x vers av et z vers bas) */
/* s,t : coordonnes du point correspondant de la texture compris entre (0,0) et (1,1) */
static GLdouble Ailes[NbptAiles][5] =  /* Points des Ailes */
	{
		/* { x, y, z, s, t } */
		{   0.00,   0.00, 0.0,  0.00,  0.40 },
		{  0.207, -0.073, 0.0, -0.25,  0.00 },
		{ -0.213, -0.333, 0.0, -1.00,  0.80 },
		{ -0.213, -0.063, 0.0, -0.15,  0.80 },
		{ -0.320, -0.063, 0.0, -0.15,  0.95 },
		{ -0.340, -0.044, 0.0, -0.10,  1.00 },
		{ -0.213, -0.043, 0.0, -0.10,  0.87 },
		{ -0.213,  0.043, 0.0,  0.10,  0.87 },
		{ -0.340,  0.044, 0.0,  0.10,  1.00 },
		{ -0.320,  0.063, 0.0,  0.15,  0.95 },
		{ -0.213,  0.063, 0.0,  0.15,  0.80 },
		{ -0.213,  0.333, 0.0,  1.00,  0.80 },
		{  0.207,  0.073, 0.0,  0.25,  0.00 },
    };
static GLdouble Derive[NbptDerive][5] =  /* Points de la drive */
    {
		/* { x, y, z, s, t } */
		{ -0.063, 0.0, -0.042, 1.5, 0.0 },
		{ -0.137, 0.0, -0.064, 1.2, 0.1 },
		{ -0.36 , 0.0, -0.230, 0.4, 1.0 },
		{ -0.417, 0.0, -0.230, 0.05, 1.0},
		{ -0.377, 0.0, -0.064, 0.2, 0.1 },
		{ -0.377, 0.0, -0.044, 0.2, 0.0 }
	};
static GLdouble    Aileron_G[NbptAileron][5] =  /* Points ailerons gauche */
    {
		/* { x, y, z, s, t } */
		{ -0.213,  -0.063, 0.0,  0.0,  0.0 },
		{ -0.213,  -0.333, 0.0,  1.0,  0.5 },
		{ -0.267,  -0.340, 0.0,  1.0, 1.0 },
		{ -0.287,  -0.063, 0.0,  0.0, 1.0 },
	};
static GLdouble    Aileron_D[NbptAileron][5] = /* Points ailerons droit */
    {
		/* { x, y, z, s, t } */
		{ -0.287,  0.063, 0.0,  0.0, 1.0 },
		{ -0.267,  0.340, 0.0,  1.0, 1.0 },
		{ -0.213,  0.333, 0.0,  1.0,  0.5 },
		{ -0.213,  0.063, 0.0,  0.0,  0.0 },
	};
double x,y,z,teta, ct, st, dx, dy;

    /* Cration objets*/
    quadric = gluNewQuadric();/* Nouvel objet quadric gnrique */
    gluQuadricTexture(quadric, GL_FALSE);/* qui ne sera pas ventuellemnt textur */

    tess = gluNewTess();/* Nouvel objet mosaque gnrique */
	gluTessCallback(tess, GLU_TESS_BEGIN, glBegin);/* Begin standard */
    gluTessCallback(tess, GLU_TESS_END, glEnd);/* End standard */
    /* Vertex modifi */
    gluTessCallback(tess, GLU_TESS_VERTEX, glu_vertex);

    /* Construction du corps du Mirage par une DisplayList */
    DL_Corps = glGenLists(1);/* Un numro de DisplayList */
    glNewList(DL_Corps, GL_COMPILE);/* Dfinition sans execution */
	/* Positionnement dans repere OpenGL */
	glPushMatrix(); /* Push repere Avion */
	glRotatef(-90., 0.0, 0.1, 0.0); 
	/* On passe en repre Z arrire pour les cylindres */
	/* La verrire : ovale allong en z  */
	glPushMatrix();
	   glColor3d(0.5, 0.5, 1.0);
	   glTranslated(-0.018, 0.0, -0.340);
	   glScaled(1.0, 1.0, 3.); 
	   gluSphere(quadric, 0.03, 10, 20);
	glPopMatrix();
	/* Cone du nez */
	glColor3dv(colfuselage);
	glPushMatrix();
	   glTranslated(0.0, 0.0, -0.62);
	   gluCylinder(quadric, 0.0, 0.033, 0.177, 20, 2);
	glPopMatrix();
	/* Entres d'air */
	glColor3dv(colfuselage);
	glPushMatrix();
	   glTranslated(0.0, 0.0, -0.247);
	   glScaled(1.0, 2.2, 1.0); 
	   gluCylinder(quadric, 0.033, 0.047/2.2, 0.447, 20, 2);
	glPopMatrix();
	/* Cones entre d'air */
	glColor3dv(colgrisnoir);
	glTranslated(0.0, 0.0, -0.483);
	glScaled(1.0, 2.2, 1.0); 
	gluCylinder(quadric, 0., 0.057/2.2, 0.267, 20, 2);
	glPopMatrix(); /* Retour repre avion */
	/* Aile principale */
	glColor3dv(colailes);
	glNormal3d(0.0, 0.0, -1.0);
	gluBeginPolygon(tess);/* Dbut polygone mosaque aile */
	for (i = 0; i < NbptAiles; i ++)
		 gluTessVertex(tess, Ailes[i], Ailes[i]);  /* Les points */
	gluEndPolygon(tess);/* Fin polygone mosaque aile */
	/* La drive */
	glColor3dv(colailes);
	glNormal3d(0.0, 1.0, 0.0);
	gluBeginPolygon(tess);/* Dbut polygone mosaque drive */          
	for (i = 0; i < NbptDerive; i ++)
		gluTessVertex(tess, Derive[i], Derive[i]);/* Les points */
	gluEndPolygon(tess);/* Fin polygone mosaque drive */
	/* Extrieur  */
	glPushMatrix();
		glRotatef(-90., 0.0, 0.1, 0.0); /* On repasse en repre Z arrire  */
		/* la poutre */
		glTranslated(0.0, 0.0, 0.340);
		glColor3d(0.8, 0.5, 0.0);
		gluCylinder(quadric, 0.022, 0.008, -ABi[0]-0.340-0.005, 4, 2);
		/* Le racteur (non textur) */
		glColor3dv(colgrisnoir);
		gluCylinder(quadric, 0.047, 0.040, 0.08, 20, 2);
	glPopMatrix(); /* Repere Avion */
	/* Les T */
	glPushMatrix();
	/* grand T */
		glColor3d(0.8, 0.5, 0.0);
		glTranslatef(ABi[7*3+0], 0.,0. ); 
		glRotatef(90., 1., 0., 0.);
		gluCylinder(quadric, 0.01, 0.01, ABi[3*7+1], 8, 2);
		glRotatef(180., 1., 0., 0.);
		gluCylinder(quadric, 0.01, 0.01, ABi[3*7+1], 8, 2);
	glPopMatrix(); /* Repere Avion */
	/* petit T */
	glPushMatrix();
		glTranslatef(ABi[3*3+0], 0.,0. ); 
		glRotatef(90., 1., 0., 0.);
		gluCylinder(quadric, 0.01, 0.01, ABi[3*3+1], 8, 2);
		glRotatef(180., 1., 0., 0.);
		gluCylinder(quadric, 0.01, 0.01, ABi[3*3+1], 8, 2);
	glPopMatrix();
	/* Cylindre fuselage */
	glPushMatrix();
		glRotatef(-90., 0.0, 0.1, 0.0); /* On repasse en repre Z arrire  */
		glColor3dv(colfuselage);
		glTranslated(0.0, 0.0, -0.443);
		gluCylinder(quadric, 0.04-0.007 , 0.04+0.007, 0.783, 20, 2);
	glPopMatrix(); /* Retour repere Avion */
    glEndList();/* fin de  DL_Corps */

    /* Construction Aileron gauche par une DisplayList */
	DL_Aileron_G = glGenLists(1);
	glNewList(DL_Aileron_G, GL_COMPILE);
	{
		glColor3dv(colaileron);
		glNormal3d(0.0, 1.0, 0.0);
		gluBeginPolygon(tess);
		for (i = 0; i < NbptAileron; i ++)
			gluTessVertex(tess, Aileron_G[i], Aileron_G[i]);
		gluEndPolygon(tess);
	}
	glEndList();/* fin DL_AILERON_G */

	/* Construction Aileron droit par une DisplayList */
	DL_Aileron_D = glGenLists(1);
	glNewList(DL_Aileron_D, GL_COMPILE);
	{
		glColor3dv(colaileron);
		glNormal3d(0.0, 1.0, 0.0);
		gluBeginPolygon(tess);
		for (i = 0; i < NbptAileron; i ++)
			gluTessVertex(tess, Aileron_D[i], Aileron_D[i]);
		gluEndPolygon(tess);
	}
	glEndList();/* fin DL_AILERON_D */

    /* Construction cone pour flches dans DisplayList */
	DL_Cone = glGenLists(1);
	glNewList(DL_Cone, GL_COMPILE);
		gluCylinder(quadric, 0.02, 0.0, 0.05, 4, 2); 
	glEndList();/* fin DL_Cone */

    /* Construction Veine (Rv veine avec z est vers le haut) */
	DL_Veine = glGenLists(1);
	glNewList(DL_Veine, GL_COMPILE);
		/* Le cylindre intrieur de 4m de diamtre */
		glColor3d(0.3,0.4,0.5);				/* fonc */
		glTranslated(0., 0., -1.0);
		gluCylinder(quadric, 2., 2., 1.0, 40, 2);
		glTranslated(0., 0., 1.0) ;			/* Retour Rv */
		/* Le marche-pied 4m  5m de diamtre */
		glColor3d(0.5,0.9,0.5);				/* clair */
		gluDisk(quadric, 2.0, 2.5,40,2);
		/* Le cylindre de la marche (le haut est au niveau 0) */
		glTranslated(0., 0., -0.1);
		glColor3d(0.3,0.4,0.5); /* fonc */
		gluCylinder(quadric, 2.5, 2.5, 0.1, 40, 2);
		/* Le sol extrieur (au niveau du bas de la marche  -0.1) */
		glColor3d(0.9,0.9,0.9); /* clair */
		gluDisk(quadric, 2.5, 8.,40,2);
		glTranslated(0., 0., 0.1);			/* Retour Rv */
		/* Les poteaux  */
#define Rsocle (0.35/M_SQRT2)	/* rayon socle */
#define Cs2pot 0.08				/* demi cot poteau */
#define Rpot   (Cs2pot*M_SQRT2)	/* rayon poteau */
#define AxeHi  (2.*Cs2pot + 0.02) /* distance axe tangentiel poulie - centre poteau */
#define Hpotbas 1.38
#define Rmot 0.035
#define Raxep 0.001             /* rayon axe poulie */
#define Laxep 0.1               /* longueur axe poulie */
		for(i=i3 = 0; i < 8; i++, i3 += 3)
		{
			glPushMatrix();
			/* Les axes verticaux des poulies */
			x = OHi[i3+2]; y = OHi[i3+1]; z = -OHi[i3];
			glTranslated(x, y, z-Laxep/2.);	
			glColor3d(0.1,0.1,0.1); 
			gluCylinder(quadric, Raxep, Raxep, Laxep, 4, 2);
			glPopMatrix();
			if (i == 7)
			{ 
			/* Le dernier axe */
				glPushMatrix();
				/* Les axes verticaux des poulies */
				x = OHi[i3+5]; y = OHi[i3+4]; z = -OHi[i3+3];
				glTranslated(x, y, z-Laxep/2.);	
				glColor3d(0.1,0.1,0.1); 
				gluCylinder(quadric, Raxep, Raxep, Laxep, 4, 2);
				glPopMatrix();
				x = 0.5*(OHi[i3+2]+OHi[i3+5]); y = 0.5*(OHi[i3+1]+OHi[i3+4]);
			}			

			glPushMatrix();
			/* Le socle */
			teta = atan2(y,x);
			ct = cos(teta); st = sin(teta);
			dx = AxeHi*ct; dy = AxeHi*st;
			glTranslated(x + dx , y + dy, -0.07);	/* Niveau -0.07 */
			glRotatef(teta*RAD2DEG+45., 0., 0., 1.);
			/* la marche */
			glColor3d(0.2,0.4,0.3); 
			gluCylinder(quadric, Rsocle, Rsocle, 0.07, 4, 2);
			glTranslated(0. , 0., 0.07);			/* Niveau 0 */
			/* Le dessus du socle */
			gluDisk(quadric, 0., Rsocle, 4, 2);
			/* Le poteau */
			if (i == 0) glColor3d(0.7,0.9,0.8);
			else glColor3d(0.9,0.8,0.7);
			z = flagbas[i] ? Hpotbas : -OHi[i3]+0.15;
			gluCylinder(quadric, Rpot, Rpot, z, 4, 2);
			/* Le dessus du poteau */
			glTranslated(0. , 0., z);
			gluDisk(quadric, 0.0, Rpot, 4,2);
			/* Le moteur */
			z = -z + (flagbas[i] ? Hpotbas-0.15 : 2.14);
			glRotatef(-45., 0., 0., 1.);
			glTranslated(-(Cs2pot+Rmot) , 0., z);
			glRotatef(90., 1., 0., 0.);
			if (i < 7) gluCylinder(quadric, Rmot, Rmot, 0.35, 12, 2);
			else
			{
				gluCylinder(quadric, Rmot, Rmot, 0.35, 12, 2);
				glRotatef(180., 1., 0., 0.);
				gluCylinder(quadric, Rmot, Rmot, 0.35, 12, 2);
			}
			glPopMatrix();
		}
 	glEndList();/* fin DL_Veine */

    /* Construction Poulie */
	DL_Poulie = glGenLists(1);
	glNewList(DL_Poulie, GL_COMPILE);
		glColor3d(1.,0.2,0.2); 
		glTranslated(0. , 0., -Epouls2);
		gluCylinder(quadric, Rpoul, Rpoul, Epoul, 20, 2); 
		glTranslated(0. , 0., -Laxep/2.);
		glColor3d(0.1,0.1,0.1); 
		gluCylinder(quadric, Raxep, Raxep, Laxep, 4, 2);
	glEndList();/* fin DL_Poulie */

    gluDeleteTess(tess);
    gluDeleteQuadric(quadric); 
}

/*----------------------------------------------------------------------------------*/
/* Initialisation lecture fichier trajectoire                                       *
/*  0 si Ok, 1 si erreur                                                            */
/*----------------------------------------------------------------------------------*/
static int InitLecture()
{
char nomfich[256];
int getNomOpenFich(void *, char *szNomfich, char *szTitreDlg, 
					char *szFilterDlg);
	meserrlec = 0;
	if(getNomOpenFich(NULL, nomfich,"Fichier data visu SACSO",NULL))
	{
		fdata = fopen(nomfich,"rt");
		if (fdata == NULL) meserrlec = 1;
	} 
	else meserrlec = 1;
	if (meserrlec) glutPostRedisplay(); /* Il faut redessiner la figure */
	return meserrlec;
}

/*----------------------------------------------------------------------------------*/
/* Callback lecture fichier trajectoire en tache de fond                            */
/*----------------------------------------------------------------------------------*/
static char bufdata[4096];

static void Lecture(void)
{
int n;
double bid[3];

	switch (DevInput)
	{
	case LECFICH :
        /*Lecture temps, 6 composantes position + 9 tensions = 16 valeurs */
		if (NULL != fgets(bufdata, 1023, fdata)) n = strlen(bufdata);
		else {n = -1; fclose(fdata); fdata = NULL; }
		break ;
	}
	if (n < 0) /* Fin transmission data */
	{
		DevInput = LOCAL;
		Idle_inData = 0 ;
		glutIdleFunc(Idle_inData);
		return;	
	}
	mesdatnok = 0;
	n = sscanf(bufdata,"%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf", 
			bid, OA, OA+1, OA+2, Carol, Carol+1, Carol+2, T, T+1, T+2, T+3, T+4, T+5, T+6, T+7, T+8);
	if (n != 16)
	{
		mesdatnok = 1;
		fclose(fdata);
		glutChangeToMenuEntry(MENU_LECFICH, "Lecture Fichier", MENU_LECFICH);
		DevInput = LOCAL;
		Idle_inData = 0 ;
		glutIdleFunc(Idle_inData);
		glutPostRedisplay(); /* Il faut redessiner la figure */
		return;	
	}
	carol2mrot(OA+3,scav3(bid, DEG2RAD,Carol));
	glutPostRedisplay(); /* Il faut redessiner la figure */
}

/*----------------------------------------------------------------------------------*/
/* Main Main Main Main Main Main Main Main Main Main Main Main Main Main Main Main  */
/*----------------------------------------------------------------------------------*/
int main(int argc, char *argv[])
{
int monMenu;
double bid1[9], bid2[6*9];

	glutInit(&argc, argv);
	/* creation des fenetres */
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowSize(width1, height1);
	f1 =  glutCreateWindow("Visu Sacso");
	glClearColor(0.85, 0.95, 0.95, 1.0);
	glutDisplayFunc(Redraw1);
	glutReshapeFunc(Resize1);

	/* Creation et affectation du menu contextuel */
	monMenu = glutCreateMenu(TraiteMenu1);
	glutAddMenuEntry("Aide Visu", MENU_AIDE);
	if (fModeXouF ==  X_SELECT) glutAddMenuEntry("Cde en Force/Couple",MENU_selectXouF);
	else glutAddMenuEntry("Cde en Pos/Orient.", MENU_selectXouF);
	glutAddMenuEntry("Lecture Fichier", MENU_LECFICH);
	glutAttachMenu(GLUT_RIGHT_BUTTON);

	Idle_inData = NULL;
	if (DevInput != LOCAL)
	{
		if (!InitLecture()) Idle_inData = Lecture;
	}
	glutIdleFunc(Idle_inData) ;

	/* Affectations des callbacks */
	glutSpecialFunc(Specialkeys1);
	glutKeyboardFunc(Keyboard1);
	glutIdleFunc(Idle_inData);

	/* Initialisation des positions poulies (OAi) */
	OA[0]= -1.; carol2mrot(OA+3,Carol);
	Geodir(bid1, bid2, OA, 0) ; /* pour les OAi */

	/* Prpartion des dessins */
	makemirage(); /* defini l avion + la soufflerie */

	/* C'est parti */
	glutMainLoop();
	return(0);
}

